## opam 1.2.0

=== Makefile ===
-include Makefile.config

all: opam-lib opam opam-admin opam-installer
	@

ALWAYS:
	@

opam-lib opam opam-admin opam-installer all: ALWAYS

#backwards-compat
compile with-ocamlbuild: all
	@
install-with-ocamlbuild: install
	@
libinstall-with-ocamlbuild: libinstall
	@

byte:
	$(MAKE) all USE_BYTE=true

src/%:
	$(MAKE) -C src $*

%:
	$(MAKE) -C src $@

lib-ext:
	$(MAKE) -C src_ext lib-ext

download-ext:
	$(MAKE) -C src_ext archives

clean-ext:
	$(MAKE) -C src_ext distclean

clean:
	$(MAKE) -C src $@
	$(MAKE) -C doc $@

OPAMINSTALLER_FLAGS = --prefix $(DESTDIR)$(prefix)
OPAMINSTALLER_FLAGS += --mandir $(DESTDIR)$(mandir)

# With ocamlfind, prefer to install to the standard directory rather
# than $(prefix) if there are no overrides
ifndef DESTDIR
ifneq ($(OCAMLFIND),no)
    LIBINSTALL_DIR ?= $(shell $(OCAMLFIND) printconf destdir)
endif
endif

ifneq ($(LIBINSTALL_DIR),)
    OPAMINSTALLER_FLAGS += --libdir $(LIBINSTALL_DIR)
endif

libinstall:
	$(if $(wildcard src_ext/lib/*),$(error Installing the opam libraries is incompatible with embedding the dependencies. Run 'make clean-ext' and try again))
	src/opam-installer $(OPAMINSTALLER_FLAGS) opam-lib.install

install:
	src/opam-installer $(OPAMINSTALLER_FLAGS) opam.install

libuninstall:
	src/opam-installer -u $(OPAMINSTALLER_FLAGS) opam-lib.install

uninstall:
	src/opam-installer -u $(OPAMINSTALLER_FLAGS) opam.install

.PHONY: tests tests-local tests-git
tests: opam opam-admin opam-check
	$(MAKE) -C tests all

# tests-local, tests-git
tests-%: opam opam-admin opam-check
	$(MAKE) -C tests $*

.PHONY: doc
doc: all
	$(MAKE) -C doc

.PHONY: man man-html
man man-html: opam opam-admin opam-installer
	$(MAKE) -C doc $@

configure: configure.ac m4/*.m4
	aclocal -I m4
	autoconf

release-tag:
	git tag -d latest || true
	git tag -a latest -m "Latest release"
	git tag -a $(version) -m "Release $(version)"


$(OPAM_FULL).tar.gz:
	$(MAKE) -C src_ext distclean
	$(MAKE) -C src_ext downloads
	rm -f $(OPAM_FULL) $(OPAM_FULL).tar.gz
	ln -s .

prefast: ALWAYS
	@if [ -n "$(wildcard src/*/*.cmi)" ]; then $(MAKE) -C src clean; fi
	$(MAKE) -C src core/opamGitVersion.ml core/opamScript.ml
	@ocp-build -init

fast: prefast
	@ocp-build
	@ln -sf ../_obuild/opam/opam.asm src/opam
	@ln -sf ../_obuild/opam-admin/opam-admin.asm src/opam-admin
	@ln -sf ../_obuild/opam-installer/opam-installer.asm src/opam-installer
	@ln -sf ../_obuild/opam-check/opam-check.asm src/opam-check

fastclean:
	@ocp-build -clean 2>/dev/null || ocp-build clean 2>/dev/null
	@rm -f $(addprefix src/, opam opam-admin opam-installer opam-check)

cold:
	./shell/bootstrap-ocaml.sh
	env PATH=$$PATH:`pwd`/bootstrap/ocaml/bin ./configure $(CONFIGURE_ARGS)
	env PATH=$$PATH:`pwd`/bootstrap/ocaml/bin $(MAKE) lib-ext
	env PATH=$$PATH:`pwd`/bootstrap/ocaml/bin $(MAKE)

=== doc/Makefile ===
ifndef OPAM
  OPAM = ../src/opam
endif
BINDIR = $(dir $(OPAM))
SRCDIR = $(wildcard ../src/*)

TOPICS  = $(shell $(OPAM) help topics)

ifndef OPAM_ADMIN
  OPAM_ADMIN = $(BINDIR)/opam-admin
endif
TOPICS_ADMIN = check depexts findlib make rename stats
HELPFMT = --help=groff

ifndef OPAM_INSTALLER
  OPAM_INSTALLER = $(BINDIR)/opam-installer
endif

SRCEXTDIR = ../src_ext/lib
INCLUDE = $(patsubst %,-I %,$(SRCDIR) $(SRCEXTDIR))

.PHONY: man html dev-manual tutorials pages
all: man dev html pages

man:
	rm -rf man
	mkdir -p man
	$(OPAM) $(HELPFMT) > man/opam.1
	for i in $(TOPICS); do\
	  $(OPAM) $$i $(HELPFMT) > man/opam-$$i.1;\
	done
	$(OPAM_ADMIN) $(HELPFMT) > man/opam-admin.1
	for i in $(TOPICS_ADMIN); do\
	  $(OPAM_ADMIN) $$i $(HELPFMT) > man/opam-admin-$$i.1;\
	done
	$(OPAM_INSTALLER) $(HELPFMT) > man/opam-installer.1

man-html: man
	rm -rf $@
	mkdir -p $@
	for f in $(wildcard man/*); do\
	  man2html -r $$f > man-html/$$(basename $$f .1).html;\
	done

tutorials:
	$(MAKE) -C tutorials

dev:
	$(MAKE) -C dev-manual

html:
	rm -rf html
	mkdir -p html/
	ocamldoc $(INCLUDE) ../src/*/*.mli ../src/*/*.ml -html -d html/ || true

pages/%.html: pages/%.md
	omd $^ -o $@

PAGES=$(wildcard pages/*.md)

pages: $(PAGES:.md=.html)

clean:
	rm -rf man html man-html pages/*.html
	$(MAKE) -C dev-manual clean
	$(MAKE) -C tutorials clean

=== src/Makefile ===
-include ../Makefile.config

ifndef version
  $(error Please run ./configure)
endif

all:
	$(MAKE) opam-lib
	$(MAKE) opam
	$(MAKE) opam-check
	$(MAKE) opam-admin
	$(MAKE) opam-installer
	$(MAKE) opamlfind
	$(MAKE) opam-admin.top

# --

OCAMLFLAGS = -g -w +a-4-9-32-41-44-45
OCAMLLDFLAGS = -g -w +a-4-9-32-41-44-45
ifeq ($(OCAML_4),true)
  OCAMLFLAGS += -bin-annot
  OCAMLLDFLAGS += -bin-annot
endif
ifeq ($(OCAML_4_01),true)
  OCAMLFLAGS += -short-paths
endif

export OCAMLFLAGS OCAMLLDFLAGS

USE_BYTE ?=
LIBEXT = $(if $(USE_BYTE),.cma,.cmxa)
BINTARGET = $(if $(USE_BYTE),byte-code,native-code)

# --

ifndef HAS_LIBEXT
  HAS_LIBEXT := $(wildcard ../src_ext/lib)
endif

ifneq ($(HAS_LIBEXT),)
  EXT_INCDIRS = ../src_ext/lib
  LIBS = unix extlib re cmdliner graph cudf dose_common dose_debian dose_algo uutf jsonm
else
  ifeq ($(HAS_PACKAGES),)
    $(error Dependencies missing. Either run 'make lib-ext' or install them and re-run './configure')
  endif
  export PACKS
  # Reset command name for ocamlfind
  OCAMLC = ocamlc
  OCAMLOPT = ocamlopt
  OCAMLDEP = ocamldep
  OCAMLLEX = ocamllex
  OCAMLYACC = ocamlyacc
  OCAMLMKLIB = ocamlmklib
  OCAMLDOC = ocamldoc
  export OCAMLC OCAMLOPT OCAMLDEP OCAMLLEX OCAMLYACC OCAMLMKLIB OCAMLDOC
endif


# --

SUBS = core solver repositories client
OPAMLIB = $(patsubst %,./opam-%,$(SUBS))
INCDIRS = $(EXT_INCDIRS) $(SUBS)

export INCDIRS

opam-lib.byte:
	$(MAKE) $(OPAMLIB:=.cma)

opam-lib.native:
	$(MAKE) $(OPAMLIB:=.cmxa)

opam-lib: opam-lib.byte $(if $(USE_BYTE),,opam-lib.native) opam-admin.top
	@

addmli = $(foreach ml,$(2),$(wildcard $(addsuffix .mli,$(basename $(1)/$(ml)))) $(1)/$(ml))

subtarget = SUBTARGET=$(if $(patsubst %.cma,,$@),native-code-library,byte-code-library)

opam-%.cma opam-%.cmxa:
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBPROJS=$* $(subtarget)

ALWAYS:
	@

# -- opam-core -- #
opam-core.cma opam-core.cmxa: core/opamScript.ml core/opamGitVersion.ml ALWAYS

# Only rebuit after a 'make clean'
core/opamGitVersion.ml: ../shell/get-git-id.ml
	cd .. && ocaml shell/get-git-id.ml src/$@
	touch $@

core/opamScript.ml: ../shell core/opamVersion.ml
	ocaml ../shell/crunch.ml "complete"     < ../shell/opam_completion.sh > $@
	ocaml ../shell/crunch.ml "complete_zsh" < ../shell/opam_completion_zsh.sh >> $@
	ocaml ../shell/crunch.ml "switch_eval"  < ../shell/opam_switch_eval.sh >> $@

SRC_core = \
  opamJson.ml \
  opamLineLexer.mll \
  opamMisc.ml \
  opamScript.ml \
  opamGitVersion.ml \
  opamVersion.ml \
  opamGlobals.ml \
  opamProcess.ml \
  opamRepositoryName.ml \
  opamSwitch.ml \
  opamSystem.ml \
  opamParallel.ml \
  opamFilename.ml \
  opamPackage.ml \
  opamVariable.ml \
  opamFormula.ml \
  opamCompiler.ml \
  opamTypes.mli \
  opamTypesBase.ml \
  opamPath.ml \
  opamParser.mly \
  opamLexer.mll \
  opamFormat.ml \
  opamFile.ml \
  opamActionGraph.ml \
  opamFilter.ml \
  opamRepository.ml

define PROJ_core
  SOURCES = $(call addmli,core,$(SRC_core))
  RESULT = opam-core
endef
export PROJ_core

# -- opam-solver -- #
opam-solver.cma: opam-core.cma
opam-solver.cmxa: opam-core.cmxa

SRC_solver = \
  opamCudf.ml \
  opamHeuristic.ml \
  opamSolver.ml

define PROJ_solver
  SOURCES = $(call addmli,solver,$(SRC_solver))
  RESULT = opam-solver
endef
export PROJ_solver

# -- opam-repositories -- #
opam-repositories.cma: opam-core.cma ALWAYS
opam-repositories.cmxa: opam-core.cmxa ALWAYS

SRC_repositories = \
  opamHTTP.ml \
  opamLocal.ml \
  opamVCS.ml \
  opamGit.ml \
  opamDarcs.ml \
  opamHg.ml

define PROJ_repositories
  SOURCES = $(call addmli,repositories,$(SRC_repositories))
  RESULT = opam-repositories
endef
export PROJ_repositories

# -- opam-client -- #
opam-client.cma: opam-core.cma opam-solver.cma opam-repositories.cma ALWAYS
opam-client.cmxa: opam-core.cmxa opam-solver.cmxa opam-repositories.cmxa ALWAYS

SRC_client = \
  opamState.ml \
  opamAction.ml \
  opamSolution.ml \
  opamSwitchCommand.ml \
  opamConfigCommand.ml \
  opamRepositoryCommand.ml \
  opamPinCommand.ml \
  opamClient.ml

define PROJ_client
  SOURCES = $(call addmli,client,$(SRC_client))
  RESULT = opam-client
endef
export PROJ_client

# -- opam binary -- #
opam: $(addsuffix $(LIBEXT),$(OPAMLIB)) ALWAYS
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBPROJS=opam SUBTARGET=$(BINTARGET)

define PROJ_opam
  SOURCES = $(call addmli,client,opamArg.ml opamMain.ml)
  RESULT = opam
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opam

# -- opam utils -- #

TOOLS = opam-check opam-admin opam-installer opamlfind

$(TOOLS): opam ALWAYS
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBPROJS=$@ SUBTARGET=$(BINTARGET)

define PROJ_opam-check
  SOURCES = tools/opam_check.ml
  RESULT = opam-check
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opam-check

SRC_opam-admin = \
  opam_mk_repo.ml \
  opam_repo_check.ml \
  opam_stats.ml \
  opam_depexts_change.ml \
  opam_findlib.ml \
  opam_rename.ml \
  opam_admin.ml

define PROJ_opam-admin
  SOURCES = $(call addmli,tools,$(SRC_opam-admin))
  RESULT = opam-admin
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opam-admin

define PROJ_opam-installer
  SOURCES = tools/opam_installer.ml
  RESULT = opam-installer
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opam-installer

define PROJ_opamlfind
  SOURCES = tools/opamlfind.ml
  RESULT = opamlfind
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opamlfind

opam-admin.top: opam-lib.byte ALWAYS
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBPROJS=opam-admin-top SUBTARGET=top

define PROJ_opam-admin-top
  SOURCES = tools/opam_admin_top.ml
  RESULT = opam-admin
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opam-admin-top

# --

ifndef SUBPROJS
  export SUBPROJS = $(SUBS) opam opam-check opam-admin opam-installer opamlfind opam-admin-top
endif

OCAMLMAKEFILE = ../OCamlMakefile
export OCAMLMAKEFILE

clean-aux:
	rm -f $(OPAMLIB:=.cma) $(OPAMLIB:=.cmxa) $(OPAMLIB:=.a) $(TOOLS) opam-admin.top opam_admin_top.*
	rm -f core/opamGitVersion.ml core/opamScript.ml

clean: clean-aux

%:
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=$@

=== doc/dev-manual/Makefile ===
.PHONY: all
all: dev-manual.pdf
html: dev-manual.html

%.pdf: %.tex
	pdflatex $*
	pdflatex $*

%.html: %.tex
	hevea -fix htmlmacros.hva $<

%.txt: %.html
	links -dump $< > $@

clean:
	rm -f *~ *.log *toc *.out *.bbl *.blg *aux *.html

=== debian/changelog ===
opam (1.2.0-1+deb8u1) jessie; urgency=medium

  * Stop using insecure and no-check-certificate flags when fetching
    files using wget and curl (Closes: #818081).

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 10 Apr 2016 12:27:13 +0200

opam (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Make opam recommend aspcud (Addresses: #766985).

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 03 Nov 2014 22:29:08 +0100

opam (1.2.0~rc4-1) unstable; urgency=medium

  * Import new uptream release.
  * Do not call make autogen anymore
  * Refresh patch 0001-Fix-some-spelling-errors.patch
  * Bump minimal requirement on dose3 to 3.3~.
  * Import Uutf and Jsonm temporarily.
  * Build and install opam-installer
  * Generate core/opamGitVersion.ml core/opamScript.ml during the configure phase
  * scripts/ directory has been renamed into tools/

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 23 Oct 2014 00:04:41 +0200

=== debian/control ===
Source: opam
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
 debhelper (>= 8),
 ocaml-nox,
 camlp4,
 ocaml-findlib (>= 1.2.4),
 dh-ocaml (>= 0.9),
 libcudf-ocaml-dev,
 libdose3-ocaml-dev (>= 3.3~),
 libre-ocaml-dev,
 libcmdliner-ocaml-dev,
 libextlib-ocaml-dev,
 libocamlgraph-ocaml-dev (>= 1.8),
 curl
Build-Depends-Indep:
 texlive-latex-base,
 texlive-lang-french,
 texlive-latex-extra,
 texlive-latex-recommended,
 texlive-fonts-recommended,
 pandoc,
 latex-make
Standards-Version: 3.9.4
Homepage: http://opam.ocamlpro.com
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/opam.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/opam.git

Package: opam
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 opam-docs (= ${source:Version}),
 build-essential,
 wget | curl
Recommends:
 aspcud,
 ocaml,
 git,
 rsync
Description: package manager for OCaml
 OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
 of users and use cases, and has unique features:
  * Powerful handling of dependencies: versions constraints, optional
    dependencies, conflicts, etc.
  * Multiple repositories backends: HTTP, rsync, git
  * Ease to create packages and repositories
  * Ability to switch between different compiler versions
 .
 Typically, OPAM will probably make your life easier if you recognize
 yourself in at least one of these profiles:
  * You use multiple versions of the OCaml compiler, or you hack the compiler
    yourself and needs to frequently switch between compiler versions.
  * You use or develop software that needs a specific and/or modified version
    of the OCaml compiler to be installed.
  * You use or develop software that depends on a specific version of an OCaml
    library, or you just want to install a specific version of a package, not
    just the latest one.
  * You want to create your own packages yourself, put them on your own
    repository, with minimal effort.

Package: opam-docs
Architecture: all
Section: doc
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: package manager for OCaml (documentation)
 OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
 of users and use cases, and has unique features:
  * Powerful handling of dependencies: versions constraints, optional
    dependencies, conflicts, etc.
  * Multiple repositories backends: HTTP, rsync, git
  * Ease to create packages and repositories
  * Ability to switch between different compiler versions
 .
 Typically, OPAM will probably make your life easier if you recognize
 yourself in at least one of these profiles:
  * You use multiple versions of the OCaml compiler, or you hack the compiler
    yourself and needs to frequently switch between compiler versions.
  * You use or develop software that needs a specific and/or modified version
    of the OCaml compiler to be installed.
  * You use or develop software that depends on a specific version of an OCaml
    library, or you just want to install a specific version of a package, not
    just the latest one.
  * You want to create your own packages yourself, put them on your own
    repository, with minimal effort.
 .
 This package contains manpages and general documentation about OPAM.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR=$(CURDIR)/debian/opam
include /usr/share/ocaml/ocamlvars.mk
OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
BINEXT = $(if $(OCAML_OPT_ARCH),native,byte)

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure
	$(MAKE) -C src core/opamGitVersion.ml core/opamScript.ml
	for file in `ls -1 debian/buildsys/`; do \
		ln -s debian/buildsys/$$file; \
	done 

.PHONY: override_dh_auto_build
override_dh_auto_build:
	ocamlbuild $(OCAML_BEST).otarget
ifneq (,$(findstring opam-docs, $(shell dh_listpackages)))
	$(MAKE) -C doc OPAM=../opamMain.$(BINEXT) OPAM_ADMIN=../opam_admin.$(BINEXT) OPAM_INSTALLER=../opam_installer.$(BINEXT) man
	$(RM) -f doc/dev-manual/dev-manual.pdf
	$(MAKE) -C doc/dev-manual
endif

.PHONY: override_dh_auto_test
override_dh_auto_test:
	true

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p $(DESTDIR)/usr/bin
	cp _build/src/client/opamMain.$(BINEXT)			$(DESTDIR)/usr/bin/opam
	cp _build/src/tools/opam_admin.$(BINEXT)		$(DESTDIR)/usr/bin/opam-admin
	cp _build/src/tools/opam_installer.$(BINEXT)		$(DESTDIR)/usr/bin/opam-installer

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	for file in `ls -1 debian/buildsys/`; do \
		$(RM) -f $$file || true; \
	done
	$(MAKE) clean || true
	$(RM) -rf _build
	$(RM) -f src/core/opamVersion.ml src/core/opamGitVersion.ml src/core/opamScript.ml Makefile.config config.log config.status *.$(BINEXT)

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -X.pdf

## opam 1.2.2

=== Makefile ===
--- 
+++ 
@@ -98,21 +98,30 @@
 	rm -f $(OPAM_FULL) $(OPAM_FULL).tar.gz
 	ln -s .
 
-prefast: ALWAYS
-	@if [ -n "$(wildcard src/*/*.cmi)" ]; then $(MAKE) -C src clean; fi
-	$(MAKE) -C src core/opamGitVersion.ml core/opamScript.ml
+fastlink:
+	@$(foreach b,opam opam-admin opam-installer opam-check,\
+	   ln -sf ../_obuild/$b/$b.asm src/$b;)
+	@$(foreach l,core solver repositories client,\
+	   $(foreach e,a cma cmxa,ln -sf ../_obuild/opam-$l/opam-$l.$e src/opam-$l.$e;)\
+	   ln -sf $(addprefix ../../,\
+	        $(foreach e,o cmo cmx cmi cmt cmti,$(wildcard _obuild/opam-$l/*.$e)))\
+	      src/$l/;)
+
+rmartefacts: ALWAYS
+	@rm -f $(addprefix src/, opam opam-admin opam-installer opam-check)
+	@$(foreach l,core solver repositories client,\
+	   $(foreach e,a cma cmxa,rm -f src/opam-$l.$e;)\
+	   $(foreach e,o cmo cmx cmi cmt cmti,rm -f $(wildcard src/$l/*.$e);))
+
+prefast: rmartefacts src/client/opamGitVersion.ml src/core/opamScript.ml src/core/opamCompat.ml src/core/opamCompat.mli
 	@ocp-build -init
 
 fast: prefast
 	@ocp-build
-	@ln -sf ../_obuild/opam/opam.asm src/opam
-	@ln -sf ../_obuild/opam-admin/opam-admin.asm src/opam-admin
-	@ln -sf ../_obuild/opam-installer/opam-installer.asm src/opam-installer
-	@ln -sf ../_obuild/opam-check/opam-check.asm src/opam-check
+	@$(MAKE) fastlink
 
-fastclean:
+fastclean: rmartefacts
 	@ocp-build -clean 2>/dev/null || ocp-build clean 2>/dev/null
-	@rm -f $(addprefix src/, opam opam-admin opam-installer opam-check)
 
 cold:
 	./shell/bootstrap-ocaml.sh

=== admin-scripts/Makefile ===
%: %.ml
	sed 's/^#.*//' $< >$*-tmp.ml
	ocamlfind ocamlc -package opam-lib,opam-lib.repositories -linkpkg ../src/tools/opam_admin_top.ml $*-tmp.ml -o $@
	rm $*-tmp.ml

=== doc/Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 SRCEXTDIR = ../src_ext/lib
 INCLUDE = $(patsubst %,-I %,$(SRCDIR) $(SRCEXTDIR))
 
-.PHONY: man html dev-manual tutorials pages
+.PHONY: man html dev-manual pages
 all: man dev html pages
 
 man:
@@ -42,9 +42,6 @@
 	  man2html -r $$f > man-html/$$(basename $$f .1).html;\
 	done
 
-tutorials:
-	$(MAKE) -C tutorials
-
 dev:
 	$(MAKE) -C dev-manual
 
@@ -63,4 +60,3 @@
 clean:
 	rm -rf man html man-html pages/*.html
 	$(MAKE) -C dev-manual clean
-	$(MAKE) -C tutorials clean

=== src/Makefile ===
--- 
+++ 
@@ -15,14 +15,18 @@
 
 # --
 
-OCAMLFLAGS = -g -w +a-4-9-32-41-44-45
-OCAMLLDFLAGS = -g -w +a-4-9-32-41-44-45
+OCAMLFLAGS = -g -w +a-4-9-32-41-44-45-48
+OCAMLLDFLAGS = -g -w +a-4-9-32-41-44-45-48
 ifeq ($(OCAML_4),true)
   OCAMLFLAGS += -bin-annot
   OCAMLLDFLAGS += -bin-annot
 endif
 ifeq ($(OCAML_4_01),true)
   OCAMLFLAGS += -short-paths
+endif
+ifeq ($(OCAML_4_02),true)
+  OCAMLFLAGS += -safe-string
+  OCAMLLDFLAGS += -safe-string
 endif
 
 export OCAMLFLAGS OCAMLLDFLAGS
@@ -85,24 +89,28 @@
 	@
 
 # -- opam-core -- #
-opam-core.cma opam-core.cmxa: core/opamScript.ml core/opamGitVersion.ml ALWAYS
-
-# Only rebuit after a 'make clean'
-core/opamGitVersion.ml: ../shell/get-git-id.ml
-	cd .. && ocaml shell/get-git-id.ml src/$@
-	touch $@
+opam-core.cma opam-core.cmxa: core/opamScript.ml core/opamCompat.ml core/opamCompat.mli ALWAYS
 
 core/opamScript.ml: ../shell core/opamVersion.ml
 	ocaml ../shell/crunch.ml "complete"     < ../shell/opam_completion.sh > $@
 	ocaml ../shell/crunch.ml "complete_zsh" < ../shell/opam_completion_zsh.sh >> $@
 	ocaml ../shell/crunch.ml "switch_eval"  < ../shell/opam_switch_eval.sh >> $@
 
+ifeq ($(OCAML_4_02),true)
+  COMPATV = 4.02
+else
+  COMPATV = 4.01
+endif
+
+core/opamCompat.%: core/opamCompat.%.$(COMPATV)
+	cp -f $< $@
+
 SRC_core = \
+  opamCompat.ml \
   opamJson.ml \
   opamLineLexer.mll \
   opamMisc.ml \
   opamScript.ml \
-  opamGitVersion.ml \
   opamVersion.ml \
   opamGlobals.ml \
   opamProcess.ml \
@@ -121,9 +129,9 @@
   opamParser.mly \
   opamLexer.mll \
   opamFormat.ml \
+  opamFilter.ml \
   opamFile.ml \
   opamActionGraph.ml \
-  opamFilter.ml \
   opamRepository.ml
 
 define PROJ_core
@@ -186,11 +194,16 @@
 export PROJ_client
 
 # -- opam binary -- #
-opam: $(addsuffix $(LIBEXT),$(OPAMLIB)) ALWAYS
+
+client/opamGitVersion.ml: ALWAYS
+	cd .. && ocaml shell/get-git-id.ml src/$@
+	touch $@
+
+opam: $(addsuffix $(LIBEXT),$(OPAMLIB)) client/opamGitVersion.ml ALWAYS
 	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBPROJS=opam SUBTARGET=$(BINTARGET)
 
 define PROJ_opam
-  SOURCES = $(call addmli,client,opamArg.ml opamMain.ml)
+  SOURCES = $(call addmli,client,opamGitVersion.ml opamArg.ml opamMain.ml)
   RESULT = opam
   LIBS = $(LIBS) $(OPAMLIB)
 endef
@@ -261,7 +274,7 @@
 
 clean-aux:
 	rm -f $(OPAMLIB:=.cma) $(OPAMLIB:=.cmxa) $(OPAMLIB:=.a) $(TOOLS) opam-admin.top opam_admin_top.*
-	rm -f core/opamGitVersion.ml core/opamScript.ml
+	rm -f client/opamGitVersion.ml core/opamScript.ml core/opamCompat.ml core/opamCompat.mli
 
 clean: clean-aux

=== tests/Makefile ===
TMP_DIR   = $(realpath .)/tmp
OPAM_ROOT = $(TMP_DIR)/OPAM.ROOT
OPAM_REPO = $(TMP_DIR)/OPAM.REPO

# repositoy name
REPO      = test
REPOKIND ?= local

# To test GIT repo
OPAM_GIT = $(TMP_DIR)/OPAM.GIT

PACKAGES  = P1-1 P1-2 P2 P3 P4 P5

ifndef OPAM
  OPAM = $(realpath ../src/opam)
endif
ENV   = PATH=$(PATH) $(DEBUG) OPAMKEEPBUILDDIR=1 OPAMROOT=$(OPAM_ROOT) OPAMNOBASEPACKAGES=1 OPAMYES=1 OPAM=$(OPAM)
OPAMBIN  = $(ENV) $(OPAM)
ifndef CHECK
  CHECK = $(ENV) $(dir $(OPAM))/opam-check
endif

ifeq ($(OPAMTESTQUIET), 1)
  DEBUG =
else
  DEBUG = OPAMDEBUG=2 OCAMLRUNPARAM=b
endif

ARCHIVES  = $(PACKAGES:%=packages/%.tar.gz)

.PHONY: all local git

all: local git
	@

quiet:
	$(MAKE) OPAMTESTQUIET=1 all

printf = /usr/bin/printf

define RUN
@$(printf) "\e[1m- %-20s\e[m ..................................... " $(1); \
if $(MAKE) $(1) >test.log 2>&1; then \
  $(printf) "\e[32m[ OK ]\e[m\n"; \
else \
  $(printf) "\e[31m[FAIL]\e[m\n\n"; \
  cat test.log; \
  $(printf) "\n\e[31m>> %s FAILED <<\e[m\n" $(1); \
  exit 1; \
fi; \
cat test.log >> fulltest.log
endef

run:
	$(call RUN,init)
	$(call RUN,upload)
	$(call RUN,install-remove)
	$(call RUN,list)
	$(call RUN,install-opt)
	$(call RUN,list)
	$(call RUN,install)
	$(call RUN,list)
	$(call RUN,reinstall)
	$(call RUN,list)
	$(call RUN,upload-new)
	$(call RUN,list)
	$(call RUN,upgrade)
	$(call RUN,list)
	$(call RUN,downgrade)
	$(call RUN,list)
	$(call RUN,switch-alias)
	$(call RUN,list)
	$(call RUN,switch-env-packages)
	$(call RUN,repo)
	$(call RUN,list)
	@echo "SUCCESS!"

local:
	$(MAKE) clean
	$(MAKE) REPOKIND=local run

git:
	$(MAKE) clean
	$(MAKE) REPOKIND=git run

init:
	rm -rf $(OPAM_REPO)
	mkdir -p $(OPAM_REPO)
ifeq ($(REPOKIND), git)
	cd $(OPAM_REPO) && git init && \
	  touch README && git add README && \
	  git commit -a -m "Initial commit"
endif
	$(OPAMBIN) init --no-setup --no-base-packages $(REPO) $(OPAM_REPO) -k $(REPOKIND)

upload: $(ARCHIVES)
	mkdir -p $(OPAM_REPO)/packages/P1.1
	cp packages/P1-1.opam     $(OPAM_REPO)/packages/P1.1/opam
	cp packages/P1-1/README   $(OPAM_REPO)/packages/P1.1/descr
	mkdir -p $(OPAM_REPO)/packages/P2.1
	cp packages/P2/README     $(OPAM_REPO)/packages/P2.1/descr
	cp packages/P2.opam       $(OPAM_REPO)/packages/P2.1/opam
	mkdir -p $(OPAM_REPO)/packages/P3.1~weird-version.test
	cp packages/P3.opam       $(OPAM_REPO)/packages/P3.1~weird-version.test/opam
	cp packages/P3/README     $(OPAM_REPO)/packages/P3.1~weird-version.test/descr
	mkdir -p $(OPAM_REPO)/packages/P4.1
	cp packages/P4-1.opam     $(OPAM_REPO)/packages/P4.1/opam
	cp packages/P4/README     $(OPAM_REPO)/packages/P4.1/descr
	mkdir -p $(OPAM_REPO)/packages/P5.1
	cp packages/P5.opam       $(OPAM_REPO)/packages/P5.1/opam
	cp packages/P5/README     $(OPAM_REPO)/packages/P5.1/descr
	mkdir -p $(OPAM_REPO)/compilers
	cp compilers/*            $(OPAM_REPO)/compilers/
ifeq ($(REPOKIND), git)
	echo 'git: "$(OPAM_GIT)/P1-1"' > $(OPAM_REPO)/packages/P1.1/url
	cd $(OPAM_REPO)/packages/P1.1/ && git add * && git commit -a -m "Adding P1"
	echo 'git: "$(OPAM_GIT)/P2"'   > $(OPAM_REPO)/packages/P2.1/url
	cd $(OPAM_REPO)/packages/P2.1/ && git add * && git commit -a -m "Adding P2"
	echo 'git: "$(OPAM_GIT)/P3"'   > $(OPAM_REPO)/packages/P3.1~weird-version.test/url
	cd $(OPAM_REPO)/packages/P3.1~weird-version.test/ && git add * && git commit -a -m "Adding P3"
	echo 'git: "$(OPAM_GIT)/P4"'   > $(OPAM_REPO)/packages/P4.1/url
	cd $(OPAM_REPO)/packages/P4.1/ && git add * && git commit -a -m "Adding P4"
	echo 'git: "$(OPAM_GIT)/P5"'   > $(OPAM_REPO)/packages/P5.1/url
	cd $(OPAM_REPO)/packages/P5.1/ && git add * && git commit -a -m "Adding P5"
	cd $(OPAM_REPO)/compilers && git add * && git commit -a -m "Adding compilers"
	rm -rf $(OPAM_GIT) && mkdir -p $(OPAM_GIT)
	mkdir $(OPAM_GIT)/P1-1 && cp packages/P1-1/* $(OPAM_GIT)/P1-1/
	mkdir $(OPAM_GIT)/P2   && cp packages/P2/*   $(OPAM_GIT)/P2/
	mkdir $(OPAM_GIT)/P3   && cp packages/P3/*   $(OPAM_GIT)/P3/
	mkdir $(OPAM_GIT)/P4   && cp packages/P4/*   $(OPAM_GIT)/P4/
	mkdir $(OPAM_GIT)/P5   && cp packages/P5/*   $(OPAM_GIT)/P5/
	cd $(OPAM_GIT)/P1-1 && git init && git add * && git commit -a -m "initial commit"
	cd $(OPAM_GIT)/P2   && git init && git add * && git commit -a -m "initial commit"
	cd $(OPAM_GIT)/P3   && git init && git add * && git commit -a -m "initial commit"
	cd $(OPAM_GIT)/P4   && git init && git add * && git commit -a -m "initial commit"
	cd $(OPAM_GIT)/P5   && git init && git add * && git commit -a -m "initial commit"
else
	mkdir -p $(OPAM_REPO)/archives
	cp packages/P1-1.tar.gz $(OPAM_REPO)/archives/P1.1+opam.tar.gz
	cp packages/P2.tar.gz $(OPAM_REPO)/archives/P2.1+opam.tar.gz
	cp packages/P3.tar.gz $(OPAM_REPO)/archives/P3.1~weird-version.test+opam.tar.gz
	cp packages/P4.tar.gz $(OPAM_REPO)/archives/P4.1+opam.tar.gz
	cp packages/P5.tar.gz $(OPAM_REPO)/archives/P5.1+opam.tar.gz
endif
	$(OPAMBIN) update

list:
	$(OPAMBIN) list -a

install-remove:
	$(CHECK) -l install-remove-1
	$(OPAMBIN) install P1
	$(CHECK) -l install-remove-2 P1.1
	$(OPAMBIN) remove P1
	$(CHECK) -l install-remove-3

install-opt:
	$(CHECK) -l install-opt-1
	$(OPAMBIN) install P5
	test -f $(OPAM_ROOT)/system/lib/p5/p2_absent
	$(CHECK) -l install-opt-2 P1.1 P5.1
	$(OPAMBIN) remove P5
	$(CHECK) -l install-opt-3 P1.1
	$(OPAMBIN) install P5
	$(CHECK) -l install-opt-4 P1.1 P5.1
	$(OPAMBIN) remove P5 -a
	$(CHECK) -l install-opt-5
	$(OPAMBIN) install P5
	$(CHECK) -l install-opt-6 P1.1 P5.1
	$(OPAMBIN) install P2
	test -f $(OPAM_ROOT)/system/lib/p5/p2_present
	$(CHECK) -l install-opt-7 P1.1 P2.1 P5.1
	$(OPAMBIN) remove P5 -a
	$(CHECK) -l install-opt-8 P1.1 P2.1
	$(OPAMBIN) remove P2 -a
	$(CHECK) -l install-opt-9
	$(OPAMBIN) install P1 P2 P5
	test -f $(OPAM_ROOT)/system/lib/p5/p2_present
	$(CHECK) -l install-opt-10 P1.1 P2.1 P5.1
	$(OPAMBIN) remove P2 -a
	test -f $(OPAM_ROOT)/system/lib/p5/p2_absent
	$(CHECK) -l install-opt-11 P1.1 P5.1
	$(OPAMBIN) remove P1
	$(CHECK) -l install-opt-12

install:
	$(CHECK) -l install-1
	$(OPAMBIN) install P1
	$(CHECK) -l install-2 P1.1
	$(OPAMBIN) install P2
	$(CHECK) -l install-3 P1.1 P2.1
	$(OPAMBIN) install P3
	$(CHECK) -l install-4 P1.1 P2.1 P3.1~weird-version.test
	$(OPAMBIN) install P4
	$(CHECK) -l install-5 P1.1 P2.1 P3.1~weird-version.test P4.1

reinstall:
	$(CHECK) -l reinstall-1 P1.1 P2.1 P3.1~weird-version.test P4.1
	$(OPAMBIN) reinstall P1
	$(CHECK) -l reinstall-2 P1.1 P2.1 P3.1~weird-version.test P4.1

upload-new:
	mkdir $(OPAM_REPO)/packages/P4.2
	cp packages/P4-2.opam   $(OPAM_REPO)/packages/P4.2/opam
	cp packages/P4/README   $(OPAM_REPO)/packages/P4.2/descr
	mkdir $(OPAM_REPO)/packages/P4.3
	cp packages/P4-3.opam   $(OPAM_REPO)/packages/P4.3/opam
	cp packages/P4/README   $(OPAM_REPO)/packages/P4.3/descr
ifeq ($(REPOKIND), git)
	echo "(* new line *)" >> $(OPAM_GIT)/P1-1/p1.ml
	cd $(OPAM_GIT)/P1-1 && git commit -a -m "a small change"
	echo 'git: "$(OPAM_GIT)/P4"' > $(OPAM_REPO)/packages/P4.2/url
	echo 'git: "$(OPAM_GIT)/P4"' > $(OPAM_REPO)/packages/P4.3/url
	cd $(OPAM_REPO) && git add * && git commit -a -m "Adding P4.2 and P4.3"
else
	mkdir $(OPAM_REPO)/packages/P1.2
	cp packages/P1-2.opam   $(OPAM_REPO)/packages/P1.2/opam
	cp packages/P1-2/README $(OPAM_REPO)/packages/P1.2/descr
	cp packages/P1-2.tar.gz $(OPAM_REPO)/archives/P1.2+opam.tar.gz
	cp packages/P4.tar.gz $(OPAM_REPO)/archives/P4.2+opam.tar.gz
	cp packages/P4.tar.gz $(OPAM_REPO)/archives/P4.3+opam.tar.gz
endif
	$(OPAMBIN) update

upgrade:
	$(CHECK) -l upgrade-1 P1.1 P2.1 P3.1~weird-version.test P4.1
	$(OPAMBIN) upgrade
ifeq ($(REPOKIND), git)
	$(CHECK) -l upgrade-2 P1.1 P2.1 P3.1~weird-version.test P4.3
else
	$(CHECK) -l upgrade-2 P1.2 P2.1 P3.1~weird-version.test P4.3
endif

downgrade:
ifeq ($(REPOKIND), git)
	$(CHECK) -l downgrade-1 P1.1 P2.1 P3.1~weird-version.test P4.3
else
	$(CHECK) -l downgrade-1 P1.2 P2.1 P3.1~weird-version.test P4.3
endif
	$(OPAMBIN) install P4.2
	$(CHECK) -l downgrade-2 P1.1 P2.1 P3.1~weird-version.test P4.2

switch-alias:
	$(CHECK) -l switch-alias-1 P1.1 P2.1 P3.1~weird-version.test P4.2
	$(OPAMBIN) remove P3.1~weird-version.test P4.2
	$(CHECK) -l switch-alias-2 P1.1 P2.1
	$(OPAMBIN) switch export $(TMP_DIR)/export
	$(OPAMBIN) switch install test --alias-of system --no-base-packages
	$(CHECK) -l switch-alias-3
	$(OPAMBIN)	switch import $(TMP_DIR)/export
	$(CHECK) -l switch-alias-4 P1.1 P2.1
	$(OPAMBIN) switch install test2 --alias-of 20
	$(CHECK) -l switch-alias-5
	$(OPAMBIN) install P1
	$(CHECK) -l switch-alias-6 P1.1
	$(OPAMBIN) switch system
	$(CHECK) -l switch-alias-7 P1.1 P2.1
	$(OPAMBIN) switch remove test test2

switch-env-packages:
	$(CHECK) -l switch-env-packages-1 P1.1 P2.1
	$(OPAMBIN) switch 10+a+b
ifeq ($(REPOKIND), git)
	$(CHECK) -l switch-env-packages-2 P1.1 P2.1 P3.1~weird-version.test P4.3
else
	$(CHECK) -l switch-env-packages-2 P1.2 P2.1 P3.1~weird-version.test P4.3
endif
	./test-TEST.sh $(wildcard $(OPAM_ROOT)/10+a+b/build/P4.3/P4*.env) "1"

repo:
	$(OPAMBIN) repo add $(REPO)2 $(OPAM_REPO) -k $(REPOKIND)
	$(OPAMBIN) repo remove $(REPO)2
	$(OPAMBIN) repo remove $(REPO)

packages/%.tar.gz: packages/% 
	cd packages && tar czf $*.tar.gz $* 

clean:
	rm -f test.log fulltest.log
	rm -f $(ARCHIVES)
	rm -rf $(TMP_DIR)

=== debian/changelog ===
opam (1.2.2-6) unstable; urgency=medium

  * Team upload
  * Add ocamlbuild to Build-Depends
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Fri, 21 Jul 2017 18:06:52 +0200

opam (1.2.2-5) unstable; urgency=medium

  * Stop using insecure and no-check-certificate flags (Closes: #818081).
    - add patch 0003-remove-insecure-no-check-certificate-flags.patch
    Thanks to Ximin Luo for submitting the bug and providing the patch.

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 19 Mar 2016 08:44:34 +0100

opam (1.2.2-4) unstable; urgency=medium

  * Fix integration with fish shell (Closes: #805270)

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 22 Dec 2015 12:17:38 +0100

opam (1.2.2-3) unstable; urgency=medium

  * Port to Dose3 4.0.1 (Closes: #797451)
    - Add 0001-Port-to-Dose3-4.0.1.patch
    - Bump build-dependency on dose3 to >= 4.0.1-2~

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 14 Sep 2015 23:17:07 +0200

opam (1.2.2-2) unstable; urgency=medium

  * Run testsuite only on native architectures: Testsuite uses ocamlopt
    unconditionally, which fails on bytecode architectures. Next upstream
    release might fix that.

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 30 Jul 2015 21:35:28 +0000

opam (1.2.2-1) unstable; urgency=medium

  * New upstream release.
    - New Build-Dependency: libjsonm-ocaml-dev
    - Drop old patches.
    - Requires libcmdliner-ocaml-dev (>= 0.9.7)
  * Use upstream's makefile based build system instead of crafting our
    own one.
  * Run package tests at build-time (Closes: #766487)
    - New Build-Dependencies: rsync and unzip.
  * Bump Standards-Version to 3.9.6, no changes required.
  * Update d/copyright file
  * Make opam recommend darcs and mercurial (Closes: #766985).
  * Make opam depend on tar and unzip.

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 28 Jul 2015 23:09:04 +0000

=== debian/control ===
--- 
+++ 
@@ -7,15 +7,19 @@
 Build-Depends:
  debhelper (>= 8),
  ocaml-nox,
+ ocamlbuild,
  camlp4,
  ocaml-findlib (>= 1.2.4),
  dh-ocaml (>= 0.9),
  libcudf-ocaml-dev,
- libdose3-ocaml-dev (>= 3.3~),
+ libdose3-ocaml-dev (>= 4.0.1-2~),
  libre-ocaml-dev,
- libcmdliner-ocaml-dev,
+ libcmdliner-ocaml-dev (>= 0.9.7~),
  libextlib-ocaml-dev,
  libocamlgraph-ocaml-dev (>= 1.8),
+ libjsonm-ocaml-dev,
+ rsync,
+ unzip,
  curl
 Build-Depends-Indep:
  texlive-latex-base,
@@ -25,10 +29,10 @@
  texlive-fonts-recommended,
  pandoc,
  latex-make
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://opam.ocamlpro.com
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/opam.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/opam.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/opam.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/opam.git
 
 Package: opam
 Architecture: any
@@ -38,11 +42,15 @@
  ${misc:Depends},
  opam-docs (= ${source:Version}),
  build-essential,
+ tar,
+ unzip,
  wget | curl
 Recommends:
  aspcud,
  ocaml,
  git,
+ darcs,
+ mercurial,
  rsync
 Description: package manager for OCaml
  OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR=$(CURDIR)/debian/tmp
include /usr/share/ocaml/ocamlvars.mk
OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
BINEXT = $(if $(OCAML_OPT_ARCH),native,byte)

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE)
ifneq (,$(findstring opam-docs, $(shell dh_listpackages)))
	$(MAKE) man
	$(RM) -f doc/dev-manual/dev-manual.pdf
	$(MAKE) -C doc/dev-manual
endif

.PHONY: override_dh_auto_test
override_dh_auto_test:
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	$(MAKE) opam-check # Needed to run some tests
	$(MAKE) -C tests local
endif

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) install prefix=$(DESTDIR)/usr

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	$(MAKE) clean || true
	$(RM) -f doc/dev-manual/dev-manual.pdf
	$(RM) -f META Makefile.config config.log config.status src/core/opamTypes.cmti src/core/opamVersion.ml tests/fulltest.log tests/packages/*.tar.gz tests/test.log
	$(RM) -rf tests/tmp

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -X.pdf

## opam 2.0.0

=== release/Makefile ===
TAG = master
VERSION = $(shell git describe $(TAG))
OPAM_VERSION = $(subst -,~,$(VERSION))
GIT_URL = ..

FULL_ARCHIVE_URL = https://github.com/ocaml/opam/releases/download/$(VERSION)/opam-full-$(VERSION).tar.gz

TARGETS = x86_64-linux i686-linux armhf-linux arm64-linux
# todo: x86_64-darwin

OCAMLV = 4.04.2
# currently hardcoded in Dockerfile.in
OCAML_URL = https://caml.inria.fr/pub/distrib/ocaml-$(basename $(OCAMLV))/ocaml-$(OCAMLV).tar.gz

HOST_OS = $(shell uname -s | tr A-Z a-z)
HOST = $(shell uname -m)-$(HOST_OS)

all: $(patsubst %,out/opam-$(VERSION)-%,$(TARGETS))

out/opam-full-$(VERSION).tar.gz:
	mkdir -p out
	cd out && curl -OfL $(FULL_ARCHIVE_URL) || { \
	  git clone $(GIT_URL) -b $(TAG) --depth 1 opam-full-$(VERSION); \
	  sed -i 's/^AC_INIT(opam,.*)/AC_INIT(opam,$(OPAM_VERSION))/' \
	    opam-full-$(VERSION)/configure.ac; \
	  $(MAKE) -C opam-full-$(VERSION) configure download-ext; \
	  tar cz --exclude-vcs opam-full-$(VERSION) -f $(notdir $@); \
	  rm -rf opam-full-$(VERSION); \
	}

build/Dockerfile.x86_64-linux: Dockerfile.in
	mkdir -p build && sed 's/%TARGET_TAG%/amd64-jessie/g' $^ | sed 's/%CONF%//g' >$@
build/Dockerfile.i686-linux: Dockerfile.in
	mkdir -p build && sed 's/%TARGET_TAG%/i386-jessie/g' $^ | sed 's/%CONF%/-host i686-linux/g' >$@
build/Dockerfile.armhf-linux: Dockerfile.in
	mkdir -p build && sed 's/%TARGET_TAG%/armhf-jessie/g' $^ | sed 's/%CONF%//g' >$@
build/Dockerfile.arm64-linux: Dockerfile.in
	mkdir -p build && sed 's/%TARGET_TAG%/arm64-jessie/g' $^ | sed 's/%CONF%//g' >$@


build/%.image: build/Dockerfile.%
	docker build -t opam-build-$* -f $^ build
	touch $@

# Actually, this is for debian 8 jessie, and varies wildly
CLINKING_linux = \
-Wl,-Bstatic \
-lunix -lbigarray -lmccs_stubs -lmccs_glpk_stubs \
-lstdc++ \
-Wl,-Bdynamic \
-static-libgcc

CLINKING_darwin = \
-lunix -lbigarray -lmccs_stubs -lmccs_glpk_stubs \
-lstdc++

CLINKING_openbsd = $(CLINKING_darwin)

LINKING = (-noautolink $(patsubst %,-cclib %,$(CLINKING_$(1))))

EXPORTS_openbsd = \
CPATH=/usr/local/include: \
LIBRARY_PATH=/usr/local/lib: \


%: opam-$(VERSION)-%

opam-$(VERSION)-%: out/opam-$(VERSION)-%
	ln -sf $^ $@

# host: opam-$(VERSION)-$(HOST)

# Build for the local host. Containerised builds, below, are preferred, but not always available
build/$(HOST).env:
	mkdir -p build/$(HOST)
	cd build/$(HOST) && curl -OL $(OCAML_URL)
	cd build/$(HOST) && tar xzf ocaml-$(OCAMLV).tar.gz
	cd build/$(HOST)/ocaml-$(OCAMLV) && \
	  ./configure -prefix $(shell pwd)/build/$(HOST) && \
	  $(MAKE) world opt.opt && \
	  $(MAKE) install
	rm -rf build/$(HOST)/ocaml-$(OCAMLV) build/$(HOST)/ocaml-$(OCAMLV).tar.gz
	touch $@

# Actually builds out/opam-$(VERSION)-$(HOST), but we don't want to override the
# rule that goes through a container
host: out/opam-full-$(VERSION).tar.gz build/$(HOST).env
	rm -rf build/opam-full-$(VERSION)
	cd build && tar xzf ../$<
	( export \
	    PATH=$(shell pwd)/build/$(HOST)/bin:$$PATH \
	    MAKE=$(MAKE) \
	    $(EXPORTS_$(HOST_OS)); \
	  cd build/opam-full-$(VERSION) && \
	  ./configure && \
	  echo "$(call LINKING,$(HOST_OS))" >src/client/linking.sexp && \
	  $(MAKE) lib-ext JBUILDER_ARGS="--root=`pwd`"; \
	  $(MAKE) opam JBUILDER_ARGS="--root=`pwd`"; \
	)
	cp build/opam-full-$(VERSION)/opam out/opam-$(VERSION)-$(HOST)
	strip out/opam-$(VERSION)-$(HOST)
	rm -rf build/opam-full-$(VERSION)

# Containerised builds
out/opam-$(VERSION)-%-linux: build/%-linux.image out/opam-full-$(VERSION).tar.gz
	docker run --rm -v `pwd`/out:/src \
	  -e "VERSION=$(VERSION)" \
	  -e "TARGET=$*-linux" \
	  -e "LINKING=$(call LINKING,$(HOST_OS))" \
	  opam-build-$*-linux

clean:
	rm -rf build

distclean: clean
	rm -rf out

REMOTE_DIR = /tmp/opam-release
REMOTE_MAKE = make
remote: out/opam-full-$(VERSION).tar.gz
	ssh "$(REMOTE)" "mkdir -p $(REMOTE_DIR)/out"
	scp Makefile "$(REMOTE):$(REMOTE_DIR)/"
	scp "$^" "$(REMOTE):$(REMOTE_DIR)/$^"
	ssh "$(REMOTE)" 'sh -c "cd $(REMOTE_DIR) && ulimit -s 8192 && $(REMOTE_MAKE) host TAG=$(TAG) VERSION=$(VERSION) OCAMLV=$(OCAMLV)"'
	scp "$(REMOTE):$(REMOTE_DIR)/out/opam-$(VERSION)*" out/

=== debian/changelog ===
opam (2.0.0-5) unstable; urgency=medium

  * Team upload.
  * debian/rules: create separate targets build-indep and build-arch
    (Closes: #909542).
  * invoke in opam/{preinst,postint,postrm} dpkg-maintscript-helper
    to handle the transition of /usr/share/doc/opam from a directory
    to a symlink (Closes: #910222).
  * install README.md and CHANGES into package opam-docs. Do not install
    extra LICENSE file, add it to debian/not-installed.
  * drop invocation of dh-exec in opam-installer.install, drop
    build-dependency dh-exec.
  * list extra files to remove by dh_clean in debian/clean.
  * drop duplicated build-dependency cppo.
  * change build-dependency on jbuilder to dune.

 -- Ralf Treinen <treinen@debian.org>  Sat, 20 Oct 2018 12:16:56 +0200

opam (2.0.0-4) unstable; urgency=medium

  * Add a strict dependency on bubblewrap (Closes: #909086)

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 22 Sep 2018 11:45:08 +0200

opam (2.0.0-3) unstable; urgency=high

  * debian/control
    + Fix typo in Breaks+Replaces for opam-installer (Closes: #907403)
    + Fix typo in the Description of opam-installer

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Sat, 08 Sep 2018 02:04:24 +0200

opam (2.0.0-2) unstable; urgency=high

  * opam-installer Replaces opam-docs (<< 2.0.0-1)
    Closes: #907403

  * Declare compliance with policy v4.2.1.
    No change required.

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Tue, 04 Sep 2018 03:23:49 +0200

opam (2.0.0-1) unstable; urgency=medium

  [Nicolas Braud-Santoni]
  * Team upload.
  * Add myself to uploaders.
  * Split opam-installer in its own package
    Symlink usr/share/doc/opam to opam-installer
  * New upstream version 2.0.0 (2018-07-24)
    - Add jbuilder, cppo and libopam-file-format-ocaml-dev to Build-Depends
    - Remove obsolete patches
    - Fix the upstream testsuite

  * Update debian/copyright
  * Update debian/watch
    - Switch to uscan 4
    - Use github.com/ocaml/opam
    - Correctly handle pre-releases (alpha, beta, rc)
    - Correctly name the downloaded tarball

  * Bump Standards-Version to 4.1.5
    - debian/copyright: Use HTTPS for the format URI
    - Set Rules-Requires-Root to no

  * Update homepage to https://opam.ocaml.org

  * debian/copyright: Fix license information.
    - LICENSE states LGPL, with a linking exception, not GPL.
    - Use FSFUL label for corresponding license

  * Switch to debhelper 11
  * debian/rules
    - Rely dh_auto_test to correctly skip tests when needed
    - Fail on missing installable files

  [ Mehdi Dogguy ]
  * Add aspcud to Build-Depends as it is needed to run the testsuite
  * Move the packaging repository to salsa.debian.org
  * Add 'm4' in Recommends (LP: #1289944)
  * Promote solvers aspcud, mccs and packup as dependencies
  * Specify libdir when running configure script
  * Remove obsolete override_dh_{auto_,}install targets
  * It is not necessary to depend on 'tar' (Closes: #900118)
  * Constraint minimal required versions for:
    - ocaml >= 4.3.0
    - ocaml-re >= 1.7.2
    - cmdliner >= 1.0.2
  * Add git and openssl to build-depends (needed for the test-suite)
  * Add a 'test' target in upstream's Makefile so that dh_auto_test runs the
    test-suite.
    - Add patch 0002-Add-a-test-target.patch

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Fri, 03 Aug 2018 21:31:15 +0800

=== debian/control ===
--- 
+++ 
@@ -3,23 +3,30 @@
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
- Mehdi Dogguy <mehdi@debian.org>
+ Mehdi Dogguy <mehdi@debian.org>,
+ Nicolas Braud-Santoni <nicolas@braud-santoni.eu>
 Build-Depends:
- debhelper (>= 8),
- ocaml-nox,
+ debhelper (>= 11),
+ ocaml-nox (>= 4.3.0~),
  ocamlbuild,
- camlp4,
+ cppo (>= 1.6.0),
  ocaml-findlib (>= 1.2.4),
  dh-ocaml (>= 0.9),
+ dune,
  libcudf-ocaml-dev,
  libdose3-ocaml-dev (>= 4.0.1-2~),
- libre-ocaml-dev,
- libcmdliner-ocaml-dev (>= 0.9.7~),
+ libre-ocaml-dev (>= 1.7.2~),
+ libcmdliner-ocaml-dev (>= 1.0.2~),
  libextlib-ocaml-dev,
  libocamlgraph-ocaml-dev (>= 1.8),
+ libopam-file-format-ocaml-dev,
  libjsonm-ocaml-dev,
+ libopam-file-format-ocaml-dev,
+ aspcud,
  rsync,
  unzip,
+ openssl,
+ git,
  curl
 Build-Depends-Indep:
  texlive-latex-base,
@@ -29,10 +36,11 @@
  texlive-fonts-recommended,
  pandoc,
  latex-make
-Standards-Version: 3.9.6
-Homepage: http://opam.ocamlpro.com
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/opam.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/opam.git
+Standards-Version: 4.2.1
+Rules-Requires-Root: no
+Homepage: https://opam.ocaml.org
+Vcs-Git: https://salsa.debian.org/ocaml-team/opam.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/opam
 
 Package: opam
 Architecture: any
@@ -42,15 +50,17 @@
  ${misc:Depends},
  opam-docs (= ${source:Version}),
  build-essential,
- tar,
+ aspcud | mccs | packup,
+ opam-installer,
+ bubblewrap,
  unzip,
  wget | curl
 Recommends:
- aspcud,
  ocaml,
  git,
  darcs,
  mercurial,
+ m4,
  rsync
 Description: package manager for OCaml
  OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
@@ -102,3 +112,25 @@
     repository, with minimal effort.
  .
  This package contains manpages and general documentation about OPAM.
+
+Package: opam-installer
+Architecture: any
+Breaks: opam (<< 2.0.0-1),
+        opam-docs (<< 2.0.0-1)
+Replaces: opam (<< 2.0.0-1),
+          opam-docs (<< 2.0.0-1)
+Depends:
+ ${ocaml:Depends},
+ ${shlibs:Depends},
+ ${misc:Depends}
+Description: Utility handling (un)installation of Opam .install files
+ opam-installer is a small utility, part of Opam, that can interpret
+ Opam's .install files and take the appropriate actions.
+ .
+ OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
+ of users and use cases, and has unique features:
+  * Powerful handling of dependencies: versions constraints, optional
+    dependencies, conflicts, etc.
+  * Multiple repositories backends: HTTP, rsync, git
+  * Ease to create packages and repositories
+  * Ability to switch between different compiler versions

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1
export DH_OPTIONS=-v
export JBUILDER_ARGS=--verbose

DESTDIR=$(CURDIR)/debian/tmp
include /usr/share/ocaml/ocamlvars.mk
OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure: .configure_stamp

.configure_stamp:
	./configure --prefix=/usr --libdir=$(OCAML_STDLIB_DIR) \
		--enable-certificate-check
	touch .configure_stamp

.PHONY: override_dh_auto_build
override_dh_auto_build:
# do nothing

build-arch: .configure_stamp
	$(MAKE)

build-indep: .configure_stamp
	$(MAKE) man
	$(RM) -f doc/dev-manual/dev-manual.pdf
	$(MAKE) -C doc/dev-manual

.PHONY: override_dh_auto_test
override_dh_auto_test:
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	dh_auto_test
endif

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	$(MAKE) clean || true

.PHONY: override_dh_installdocs
override_dh_installdocs:
	dh_installdocs -p opam --link-doc=opam-installer
	dh_installdocs --remaining-packages

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -X.pdf

.PHONY: override_dh_missing
override_dh_missing:
	dh_missing --fail-missing
